#pragma once

#include "LinearAlgebra/Spherical.h"
#include "LinearAlgebra/SwingTwist.h"
#include "Thing.h"
#include "float16.h"

namespace Passer {
namespace RoboidControl {

/// @brief  Root structure for all communcation messages
class IMessage {
public:
  /// @brief Default constructor for a message
  IMessage();
  /// @brief Create a message for receiving
  /// @param buffer The byte array to parse
  IMessage(char* buffer);

  /// @brief Serialize the message into a byte array for sending
  /// @param buffer The buffer to serilize into
  /// @return The length of the message in the buffer
  virtual unsigned char Serialize(char *buffer);

};

} // namespace RoboidControl
} // namespace Passer

using namespace Passer::RoboidControl;